<template>
  <v-col md="8" cols="12">
    <v-window continuous show-arrows>
      <v-window-item v-for="print in prints" :key="print.id">
        <v-row>
          <v-col cols="10" offset="1">
            <v-card width="90vw">
              <v-carousel v-if="print.media && print.media.length !== 0"
                          height="370px"
                          :id="'carousel-' + print.id"
                          :hide-delimiters="print.media.length < 2"
                          :show-arrows="print.media.length > 1">
                <v-carousel-item v-for="media in print.media"
                                 :key="media.url">
                  <v-img v-if="!media.is_video"
                         :src="media.url"
                         :alt="media.alt"/>
                  <video v-if="media.is_video"
                         controls
                         :height="print.media.length > 1 ? '320px' : '370px'"
                         width="100%">
                    <source
                        :src="media.url"
                        :type="media.type">
                    Hey! I'm sorry but it seems like your browser doesn't support playing this video.
                  </video>
                </v-carousel-item>
              </v-carousel>
              <v-card-title>{{print.name}}</v-card-title>
              <v-card-subtitle align="left">
                {{print.description}}
              </v-card-subtitle>
              <v-card-text align="left">
              <v-row>
                <v-col md="10" cols="8">
                  <v-icon>mdi-clock</v-icon>
                  Date:
                  {{moment(new Date(print.date)).format("MMMM YYYY")}}
                  <br>
                  <span v-for="duration in print.duration" :key="duration.part">
                    <v-icon>mdi-timer</v-icon>
                    Duration{{duration.parts ? ' (' + duration.parts + ')' : ''}}:
                    {{duration.time}}
                    <br>
                  </span>
                  <span v-for="color in print.colors" :key="color.hex">
                    <v-icon>mdi-palette-swatch</v-icon>
                    Color{{color.parts ? ' (' + color.parts + ')' : ''}}:
                    {{color.name}}
                    <v-tooltip right>
                      <template v-slot:activator="{on, attrs}">
                        <span
                            :style="'background-color: ' + color.hex"
                            v-bind="attrs"
                            v-on="on">
                          &nbsp;&nbsp;&nbsp;&nbsp;</span>
                      </template>
                      <span>{{color.hex}}</span>
                    </v-tooltip>
                    <br>
                  </span>
                  <span v-for="material in print.materials" :key="material.name">
                    <v-icon>mdi-texture</v-icon>
                    Material{{material.parts ? ' (' + material.parts + ')' : ''}}:
                    {{material.name}}
                    <br>
                  </span>
                </v-col>
                <v-col cols="1">
                  <v-row>
                    <v-col cols="12" v-for="action in print.actions" :key="action.name">
                      <v-tooltip left>
                        <template v-slot:activator="{on, attrs}">
                          <v-btn
                              :href="action.url"
                              :disabled="!action.url"
                              :target="action.new_tab ? 'blank' : 'self'"
                              v-bind="attrs"
                              v-on="on">
                            <v-icon>mdi-{{action.icon}}</v-icon>
                          </v-btn>
                          <v-spacer/>
                        </template>
                        <span>{{action.title}}</span>
                      </v-tooltip>
                    </v-col>
                  </v-row>
                </v-col>
              </v-row>
            </v-card-text>
            </v-card>
          </v-col>
        </v-row>
      </v-window-item>
    </v-window>
  </v-col>
</template>

<script>
import moment from "moment";

export default {
  name: "PrintingProjects",
  data: () => ({
    moment,
    prints: [
      {
        id: "6c47nq67m",
        name: "AA & AAA battery dispenser and extensions",
        description: "Dispenser for AA and AAA batteries",
        date: "2021-11-26",
        duration: [
          {
            parts: undefined,
            time: "~10h"
          }
        ],
        colors:[
          {
            name: "Black",
            hex: "#000",
            parts: undefined
          }
        ],
        materials: [
          {
            name: "PLA",
            parts: undefined
          }
        ],
        media: [
          {
            url: "https://cdn.sgart.dev/octoprint/images/20211128-battery-dispenser-extension-aa-aaa.jpg",
            is_video: false,
            alt: "Image"
          },
          {
            url: "https://cdn.sgart.dev/octoprint/images/20211128-battery-dispenser-extension-aa-aaa.png",
            is_video: false,
            alt: "Model Screenshot"
          },
          {
            url: "https://cdn.sgart.dev/octoprint/timelapses/PI3MK3M_Batt_disp_AA_v5_20211126182532.webm",
            is_video: true,
            type: "video/webm"
          }
        ],
        actions: [
          {
            name: "source",
            title: "View source",
            url: "https://www.thingiverse.com/thing:605854",
            icon: "source-branch",
            new_tab: true
          },
          {
            name: "download",
            title: "Download model",
            url: "https://cdn.sgart.dev/octoprint/models/Batt_disp_AAA_v5.zip",
            icon: "semantic-web",
            new_tab: false
          }
        ]
      },
      {
        id: "sihfusdhf",
        name: "AAA battery box",
        description: "Box to easily store 48 AAA batteries",
        date: "2021-11-28",
        duration: [
          {
            parts: undefined,
            time: "~20.5h"
          }
        ],
        colors: [
          {
            name: "Sky Blue",
            hex: "#1e8bb7",
            parts: undefined
          }
        ],
        materials: [
          {
            name: "PLA",
            parts: undefined
          }
        ],
        media: [
          {
            url: "https://cdn.sgart.dev/octoprint/images/48_aaa_box_model.png"
          },
          {
            url: "https://cdn.sgart.dev/octoprint/timelapses/PI3MK3M_aaa_48_box_20211129164731.webm",
            is_video: true,
            type: "video/webm"
          }
        ],
        actions: [
          {
            name: "source",
            title: "View source",
            url: "https://www.thingiverse.com/thing:4921753",
            icon: "source-branch",
            new_tab: true
          },
          {
            name: "download",
            title: "Download model",
            url: "https://cdn.sgart.dev/octoprint/models/48_aaa_box.zip",
            icon: "semantic-web",
            new_tab: false
          }
        ]
      },
      {
        id: "dfdsfds",
        name: "Rocktopus",
        description: "What even is this thing?!",
        date: "2021-11-30",
        duration: [
          {
            parts: undefined,
            time: "~3h"
          }
        ],
        colors: [
          {
            name: "Sky Blue",
            hex: "#1e8bb7",
            parts: undefined
          }
        ],
        materials: [
          {
            name: "PLA",
            parts: undefined
          }
        ],
        media: [
          {
            url: "https://cdn.sgart.dev/octoprint/images/rocktopus_on_headset.jpg",
            alt: "Rocktopus on headset"
          },
          {
            url: "https://cdn.sgart.dev/octoprint/images/rocktopus_cat_approval.png",
            alt: "Rocktopus cat-approval"
          },
          {
            url: "https://cdn.sgart.dev/octoprint/images/rocktopus_model.png",
            is_video: false,
            alt: "Model Screenshot"
          },
          {
            url: "https://cdn.sgart.dev/octoprint/timelapses/PI3MK3M_rocktopus_v2_20211130161831.webm",
            is_video: true,
            type: "video/webm"

          }
        ],
        actions: [
          {
            name: "source",
            title: "View source",
            url: "https://www.thingiverse.com/thing:5142294",
            icon: "source-branch",
            new_tab: true
          },
          {
            name: "download",
            title: "Download model",
            url: "https://cdn.sgart.dev/octoprint/models/rocktopus_v2.stl",
            icon: "semantic-web",
            new_tab: false
          }
        ]
      },
      {
        id: "odshfuodsf",
        name: "Assortment Box",
        description: "Small container for various stuff",
        date: "2021-04-14",
        duration: [
          {
            parts: undefined,
            time: "~4h"
          }
        ],
        colors: [
          {
            name: "Black",
            hex: "#000",
            parts: undefined
          }
        ],
        materials: [
          {
            name: "PLA",
            parts: undefined
          }
        ],
        media: [
          {
            url: "https://cdn.sgart.dev/octoprint/timelapses/assortment_box_1x1_v4_0.15mm_PLA_MK3S_4h2m_20200629153137.webm",
            type: "video/webm",
            is_video: true
          }
        ],
        actions: [
          {
            name: "source",
            title: "View source",
            url: undefined,
            icon: "source-branch",
            new_tab: true
          },
          {
            name: "download",
            title: "Download model",
            url: undefined,
            icon: "semantic-web",
            new_tab: false
          }
        ]
      }
    ]
  })
}
</script>